defint a-z :dim default(15),linear(63),range$(3)
screen 9: cls
for attribute=0 to 7
	default(attribute)=attribute
next: default(6)=20
for attribute=8 to 15
	default(attribute)=attribute+48
next
for colornumber=0 to 63
	linear(colornumber)=colornumber
next
range$(0)=" 0-15" : range$(1)="16-31" : range$(2)="32-47" : range$(3)="48-63"
text=15 : bold=2 : inputkey=14 : messagebox=9

gosub text
gosub default

getkey:
keyin$=input$(1) : if keyin$=chr$(27) then cls : palette : end
keyin$=chr$(asc(keyin$) or &h20)	'convert input to lower case
on instr("0123dc",keyin$) gosub linear,linear,linear,linear,default,change
goto getkey

text:
gosub headings
gosub messages
gosub instructions
return

default:
palette
for attribute=0 to 15
	gosub boxes
	colornumber=default(attribute)
	gosub numbers
next
return

linear:
set=val(keyin$) : start=set*16
palette using linear(start)
for attribute=0 to 15
	gosub boxes
	colornumber=linear(start+attribute)
	gosub numbers
next
return

boxes:
top=attribute*14+28 : bottom=top+13
line (36,top)-(376,bottom),attribute,bf
return

numbers:
locate 3+attribute,1 : print attribute;
locate 3+attribute,49 : print colornumber
return

headings:
locate 1,12 : color 10
print "The Colors of Screen Mode 9 on the Enhanced Color Display"
locate 2,1 : color 12 : print "Attribute Number"
locate 2,41 : print "Color Number"
line (0,26)-(127,26),messagebox
line (320,26)-(415,26),messagebox
color text
return

messages:
line (440,39)-(632,114),messagebox,b
locate 4,57 : color bold : print "Screen Mode 9 ";
color text : print "is valid"
locate 5,57 : print "only for an Enhanced"
locate 6,57 : print "Graphics Adapter ";
color bold : print "(EGA)";
locate 7,57 : color text : print "driving an Enhanced"
locate 8,57 : print "Color Display ";
color bold : print "(ECD)";
color text : print "."
line (440,123)-(632,184),messagebox,b
locate 10,57 : print "Any of the ";
color bold : print "16 ";
color text : print "colors"
locate 11,57 : print "of a ";
color bold : print "64K ";
color text : print "EGA can be"
locate 12,57 : print "assigned to any of the"
locate 13,57 : color bold : print "4 ";
color text : print "first attributes."
line (440,193)-(632,254),messagebox,b
locate 15,57 : print "Any of the ";
color bold : print "64 ";
color text : print "colors"
locate 16,57 : print "of a ";
color bold : print "128K or 256K ";
color text : print "EGA"
locate 17,57 : print "can be assigned to any"
locate 18,57 : print "of the ";
color bold : print "16 ";
color text : print "attributes."
return

instructions:
gosub clearwindow
locate 20,1 : print "Press... ";
color inputkey : print "D ";
color text : print "to view the ";
color bold : print "default ";
color text : print "color assignments."
for set=0 to 3
	locate (21+set),9 : color inputkey : print set;
	color text : print "to assign colors ";
	color bold : print range$(set);
	color text : print " to attributes ";
	color bold : print "0-15.";
next
locate 25,10 : color inputkey : print "C ";
color text : print "to ";
color bold : print "change ";
color text : print "an attribute's assigned color.";
line (480,277)-(568,324),messagebox,b
locate 21,62 : print "Press the"
locate 22,62 : color inputkey : print "<Esc> ";
color text : print "key:
locate 23,62 : print "to quit"
return

change:
gosub clearwindow
locate 21,1
print "Enter the number of the attribute ";
color inputkey : input "to be changed: ",attribute
if attribute<0 or attribute >15 goto change

assign:
gosub clearwindow
locate 23,1 : print "Enter the color number ";
color inputkey : print "0-63 ";
color text : print "to assign to attribute";
color bold : print str$(attribute);
color text : input ": ",colornumber
if colornumber<0 or colornumber>63 goto assign
palette attribute,colornumber
gosub numbers
gosub instructions
return

clearwindow:
line (0,266)-(639,349),0,bf
return
